UNIT FixedThreeDeeCalls;

INTERFACE

	USES
		MemTypes, Memory, Packages, FixMath, QuickDraw, ToolIntf, Sound, GraphicsModuleTypes, Sounds;

TYPE
	ThreeDeePoint = RECORD
		x		: fixed;
		y		: fixed;
		z		: fixed;
	end;
	
	ThreeDeeWorld = RECORD
		eyeLocation		: ThreeDeePoint;
		screenCenter	: ThreeDeePoint;
		screenRect		: rect;
		frontTopLeft		: ThreeDeePoint;
		frontTopRight	: ThreeDeePoint;
		frontBotLeft		: ThreeDeePoint;
		frontBotRight	: ThreeDeePoint;
		backTopLeft		: ThreeDeePoint;
		backTopRight	: ThreeDeePoint;
		backBotLeft		: ThreeDeePoint;
		backBotRight		: ThreeDeePoint;
		plutoScaling		: real;
	end;
	WorldPtr		= ^ThreeDeeWorld;
	WorldHdl		= ^WorldPtr;

PROCEDURE SetThreeDeePoint (var tempPt : ThreeDeePoint; x, y, z : real);
PROCEDURE ThreeDeeToTwoDee(theWorld : ThreeDeeWorld; aThreeDeePoint : ThreeDeePoint; var a2DPoint : point);
PROCEDURE ScaleRect (var tempRect : rect; scaleFactor : real);
PROCEDURE SetupThreeDeeWorld (var tempWorld : ThreeDeeWorld; monitorRect : rect);
IMPLEMENTATION

{$I FixedThreeDeeCalls.inc1.p }

END.