/*******************************************************************************/
/* MenuSelect.c  - Written by Shane D. Looker                                  */
/* Copyright 1991 by Shane D. Looker                                           */
/*                                                                             */
/* Menu select is a patch for MenuSelect which will move the menus in the      */
/* menu bar around in a confusing way.                                         */
/*                                                                             */
/* WARNING: This only behaves correctly under System 7.                        */
/*******************************************************************************/

pascal long main(Point thePt);				/* Prototype to make the compiler happy */


/* Define the Inside Mac structures from Volume 1. */

typedef	struct {
	Handle	mH;
	short	leftEdge;
}	M;

typedef	struct {
	short	offset;
	short	rightEdge;
	short	unused;
	M		menus[];
}	hack;



pascal long main(Point thePt)				/* Entry point */
{
	Ptr		addr;
	Handle	h = GetMenuBar();				/* Get a copy of current menu bar handle 	*/
	short	i, count;
	short	t, y;
	hack	*x;
	M		temp;
	
	addr = *(Ptr *)(((Ptr)&main) - 8);		/* Get the address of the "real" MenuSelect	*/
	HLock(h);								/* Lock the menu bar handle I just got 		*/

	x = (hack *)*h;							/* Set up x for fast access					*/
	count = x->offset / 6;					/* Count the number of menus. 1-n 			*/
											/* Note that the 0th element are the first	*/
											/* 3 shorts in the hack structure 			*/
		
	temp = x->menus[1];						/* Save the left menu before we overwrite it*/
	for (i = 1; i < count-2; i+=2)			/* Move these to the left (odds) 			*/
	{
		x->menus[i] = x->menus[i+2];		/* Shift the menu left */
	}
	x->menus[i] = temp;						/* Rotate the left menu to the right side	*/
	
	i = (count - 1) & 0xFFFE;				/* Read this as (((count - 1) / 2) * 2)		*/
											/* It gives the last even menu				*/
	temp = x->menus[i];						/* Save the rightmost menu					*/
	for (; i > 3; i-=2)						/* Move these to the right (evens) */
	{
		x->menus[i] = x->menus[i-2];		/* Shift the menu right */
	}
	x->menus[2] = temp;						/* Rotate the right menu to the left side	*/
	
	
	SetMenuBar(h);							/* Replace my menu bar						*/
	DisposHandle(h);						/* Clean up my copy of the handle			*/
	DrawMenuBar();							/* Smooth update under System 7.			*/
	
	asm {
			MOVE.L		addr, A0			/* Shove the "real" MenuSelect into A0		*/
			UNLK		A6					/* Clean up my stack frame manually			*/
			JMP			(A0)				/* Go to "real" MenuSelect					*/		
	};
}