/*******************************************************************************/
/* InstallPatch.c  - Written by Shane D. Looker                                */
/* Copyright 1991 by Shane D. Looker                                           */
/*******************************************************************************/

#include	"Squeaker.h"

Ptr		PatchTrap(short	procID, long trapNum, Ptr globalStorage, short trapType);
Ptr		InstallGNE(short procID, Ptr globalStorage);

pascal	void	main(void);

typedef	struct	{
	short	resID;
	short	trapNum;
	short	globalID;
	short	trapType;
	
	}	InstallType;									/* Define my resource structure 'insT' */


pascal void main()										/* Init entry point */
{
	InstallType		**installRes;
	Handle			globalStuff;
		long		size;
		ButtonData	*sysPtr;
		Boolean	ok = true;
		Handle	sndH;
	
	if ((installRes = (InstallType **) Get1Resource('insT', 128)) != 0)	/* Get the installer resource */
	{
		long	size;

		HLock((Handle)installRes);										/* Lock it for use */
		globalStuff = Get1Resource('glob', (*installRes)->globalID);	/* Get the global data storage */
		
		if (globalStuff)										/* If I got it */
		{
			size = GetHandleSize(globalStuff);
			
			if (size > 4)										/* If it is large */
			{
				if (sysPtr = (ButtonData *)NewPtrSys(size))
				{
					
					BlockMove(*globalStuff, sysPtr, size);
					

					if (sndH = Get1Resource('snd ', 128))
					{
						size = GetHandleSize(sndH);
						if(sysPtr->sndH = NewHandleSys(size)) 
							BlockMove(*sndH, *(sysPtr->sndH), size);
						else {
						DebugStr("\pWAAAH!  No Memory!");
						}
						HLock(sysPtr->sndH);
						ReleaseResource(sndH);
					}
					else
						{
						DebugStr("\PCan't get the sound!");
						ok = false;
						}
						
					if (sysPtr->sndC = (SndChannelPtr) NewPtrSys(sizeof(SndChannel)))
					{
						short	err;
						
						sysPtr->sndC->qLength = stdQLength;
						if (err = SndNewChannel(&sysPtr->sndC, 0, 0, nil))
							ok = false;
					}

				}
				else {
					DebugStr("\PBarfo. Couldn't get Global storage area");
					ok = false;
					}
			}
			else
				sysPtr = (ButtonData *) size;
		}
		else
			DebugStr("\PHey! Didn't find the Global data!");
				
		if (ok)
		{
			if ((*installRes)->trapNum)
				PatchTrap((*installRes)->resID, (*installRes)->trapNum, (Ptr) sysPtr, (*installRes)->trapType);
			else
				InstallGNE((*installRes)->resID, (Ptr) sysPtr);
		}
	}

}


Ptr PatchTrap(short procID, long trapNum, Ptr globalStorage, short trapType)
{
	Handle	codeHand;
	long	size;
	Ptr		result = nil, installHand;
	
	codeHand = Get1Resource('PTCH', procID);					/* Get the actual code resource */
	if (codeHand)												/* If I got one */
	{
		size = GetHandleSize(codeHand);										
		result = NewPtrSys(size + 8);							/* New system pointer with 8 bytes extra */
		
		BlockMove(*codeHand, result+8, size);					/* Move code 8 bytes into the block */
		ReleaseResource(codeHand);								/* Toss the resource now */
		
		*(Ptr *)(result + 4) = globalStorage;					/* Global storage set up in 2nd long of block */
		
								/* Get the current trap address and put into 1st long word of the block */
		*(long *)result = (long) StripAddress((Ptr)NGetTrapAddress(trapNum, trapType));	
		
		NSetTrapAddress((long)StripAddress((Ptr)(result+8)), trapNum, trapType);	/* Now patch! */
		
	}
	return (result);											/* Return my code block address */
}


Ptr InstallGNE(short procID, Ptr globalStorage)
{
	Handle	codeHand;
	long	size;
	Ptr		result = nil, installHand;
	
	codeHand = Get1Resource('PTCH', procID);					/* Get the actual code resource */
	if (codeHand)												/* If I got one */
	{
		size = GetHandleSize(codeHand);										
		result = NewPtrSys(size + 8);							/* New system pointer with 8 bytes extra */
		
		BlockMove(*codeHand, result+8, size);					/* Move code 8 bytes into the block */
		ReleaseResource(codeHand);								/* Toss the resource now */
		
		*(Ptr *)(result + 4) = globalStorage;					/* Global storage set up in 2nd long of block */
		
								/* Get the current trap address and put into 1st long word of the block */
		*(long *)result = (long) StripAddress(JGNEFilter);
		JGNEFilter = result+8;						/* Now install! */
		
	}
	return (result);											/* Return my code block address */
}